﻿# -*-coding:UTF-8-*-
##########################
#Bot Kernel Code Computer#
##########################
##########################
###########################################
#Algorithme d'analyse des Temps des Verbes#
###########################################
#########################################################
#Analyse des Verbes Utilisateurs par Conjugaison Furtive#
#########################################################


######################
#Terminaison Infinitif#
######################
BDD_Terminaison_Verbes = ["er", "oir", "ir", "re"]

#####################
#Terminaison General#
#####################
Indicatif_Present_BDD =['e', 'es', 'e', 'ons', 'ez', 'ent']
Indicatif_Imparfait_BDD = ['ais', 'ais', 'ait', 'ions', 'iez', 'aient']
Indicatif_Passe_Simple_BDD = ['ai', 'as', 'a', 'âmes', 'âtes', 'èrent']
Indicatif_Futur_Simple_BDD = ['erai', 'eras', 'era', 'erons', 'erez', 'eront']
Conditionnel_Present_BDD = ['erais', 'erais', 'erait', 'erions', 'eriez', 'eraient']
Infinitif_Passe_BDD = ['é']

####################
#Auxiliaire - AVOIR#
####################
BDD_Avoir_Indicatif_Present = ['ai', 'as', 'a', 'avons', 'avez', 'ont']
BDD_Avoir_Indicatif_Passe_Compose = ['ai eu', 'as eu', 'a eu', 'avons eu', 'avez eu', 'ont eu']
BDD_Avoir_Indicatif_Imparfait = ['avais', 'avais', 'avait', 'avions', 'aviez', 'avaient']
BDD_Avoir_Indicatif_Plus_que_Parfait = ['avais eu', 'avais eu', 'avait eu', 'avions eu', 'aviez eu', 'avaient eu']
BDD_Avoir_Indicatif_Passe_Simple = ['eus', 'eus', 'eut', 'eûmes', 'eûtes', 'eurent']
BDD_Avoir_Indicatif_Passe_Anterieur = ['eus eu', 'eus eu', 'eut eu', 'eûmes eu', 'eûtes eu', 'eurent eu']
BDD_Avoir_Indicatif_Futur_Simple = ['aurai', 'auras', 'aura', 'aurons', 'aurez', 'auront']
BDD_Avoir_Indicatif_Futur_Anterieur = ['aurai eu', 'auras eu', 'aura eu', 'aurons eu', 'aurez eu', 'auront eu']
BDD_Avoir_Subjonctif_Present = ['aie', 'aies', 'ait', 'ayons', 'ayez', 'aient']
BDD_Avoir_Subjonctif_Passe = ['aie eu', 'aies eu', 'ait eu', 'ayons eu', 'ayez eu', 'aient eu']
BDD_Avoir_Subjonctif_Imparfait = ['eusse', 'eusses', 'eût', 'eussions', 'eussiez', 'eussent']
BDD_Avoir_Subjonctif_Plus_que_Parfait = ['eusse eu', 'eusses eu', 'eût eu', 'eussions eu', 'eussiez eu', 'eussent eu']
BDD_Avoir_Imperatif_Present = ['aie', 'ayons', 'ayez']
BDD_Avoir_Imperatif_Passe = ['aie eu', 'ayons eu', 'ayez eu']
BDD_Avoir_Conditionnel_Present = ['aurais', 'aurais', 'aurait', 'aurions', 'auriez', 'auraient']
BDD_Avoir_Conditionnel_Passe_Un = ['aurais eu', 'aurais eu', 'aurait eu', 'aurions eu', 'auriez eu', 'auraient eu']
BDD_Avoir_Conditionnel_Passe_Deux = ['eusse eu', 'eusses eu', 'eût eu', 'eussions eu', 'eussiez eu', 'eussent eu']
BDD_Avoir_Participe_Present = ['ayant']
BDD_Avoir_Participe_Passe = ['eu', 'ayant eu']

###################
#Auxiliaire - ETRE#
###################
BDD_Etre_Indicatif_Present = ['suis', 'es', 'est', 'sommes', 'êtes', 'sont']
BDD_Etre_Indicatif_Passe_Compose = ['ai été', 'as été', 'a été', 'avons été', 'avez été', 'ont été']
BDD_Etre_Indicatif_Imparfait = ['étais', 'étais', 'était', 'étions', 'étiez', 'étaient']
BDD_Etre_Indicatif_Plus_que_Parfait = ['avais été', 'avais été', 'avait été', 'avions été', 'aviez été', 'avaient été']
BDD_Etre_Indicatif_Passe_Simple = ['fus', 'fus', 'fut', 'fûmes', 'fûtes', 'furent']
BDD_Etre_Indicatif_Passe_Anterieur = ['eus été', 'eus été', 'eut été', 'eûmes été', 'eûtes été', 'eurent été']
BDD_Etre_Indicatif_Futur_Simple = ['serai', 'seras', 'sera', 'serons', 'serez', 'seront']
BDD_Etre_Indicatif_Futur_Anterieur = ['aurai été', 'auras été', 'aura été', 'aurons été', 'aurez été', 'auront été']
BDD_Etre_Subjonctif_Present = ['sois', 'sois', 'soit', 'soyons', 'soyez', 'soient']
BDD_Etre_Subjonctif_Passe = ['aie été', 'aies été', 'ait été', 'ayons été', 'ayez été', 'aient été']
BDD_Etre_Subjonctif_Imparfait = ['fusse', 'fusses', 'fût', 'fussions', 'fussiez', 'fussent']
BDD_Etre_Subjonctif_Plus_que_Parfait = ['eusse été', 'eusses été', 'eût été', 'eussions été', 'eussiez été', 'eussent été']
BDD_Etre_Imperatif_Present = ['sois', 'soyons', 'soyez']
BDD_Etre_Imperatif_Passe = ['aie été', 'ayons été', 'ayez été']
BDD_Etre_Conditionnel_Present = ['serais', 'serais', 'serait', 'serions', 'seriez', 'seraient']
BDD_Etre_Conditionnel_Passe_Un = ['aurais été', 'aurais été', 'aurait été', 'aurions été', 'auriez été', 'auraient été']
BDD_Etre_Conditionnel_Passe_Deux = ['eusse été', 'eusses été', 'eût été', 'eussions été', 'eussiez été', 'eussent été']
BDD_Etre_Participe_Present = ['étant']
BDD_Etre_Participe_Passe = ['été', 'ayant été']

###########################################################
#Partie 0 : Fonction de Recherche de Sujets : Operationnel#
###########################################################

def Pronom_Analyse(User):
    BDD_Pronoms = ["j'", "je", "tu", "l'", "il", "elle", "on", "nous", "vous", "ils", "elles"]
    User = User.lower()
    i = len(BDD_Pronoms)-1
    while i >= 0:
        if User == BDD_Pronoms[i] or User[0:2] == BDD_Pronoms[i]:
            return 'True', BDD_Pronoms[i]
        i -= 1
    return 0

def Sujet_Comprehension(Sujet):
    if Sujet == "j'" or Sujet == "je":
        import os
        Sujet = os.environ['USERNAME']
    if Sujet == "tu":
        Sujet = "Cindy"
    else:
        return "False"
    return Sujet

####################################################################
#Partie 1 : Fonction de Recherche des Verbes Connues : Operationnel#
####################################################################
def StringTraite(User):
    if "à" in User:
        User = User.replace("à", "a")
    if "â" in User:
        User = User.replace("â", "a")
    if "ä" in User:
        User = User.replace("ä", "o")
    if "é" in User:
        User = User.replace("é", "e")
    if "è" in User:
        User = User.replace("è", "e")
    if "ê" in User:
        User = User.replace("ê", "e")
    if "î" in User:
        User = User.replace("î", "i")
    if "ï" in User:
        User = User.replace("ï", "i")
    if "ì" in User:
        User = User.replace("ì", "i")
    if "ô" in User:
        User = User.replace("ô", "o")
    if "ö" in User:
        User = User.replace("ö", "o")
    if "ò" in User:
        User = User.replace("ò", "o")
    if "û" in User:
        User = User.replace("û", "u")
    if "ù" in User:
        User = User.replace("ù", "u")
    if "ü" in User:
        User = User.replace("ü", "u")
    return User

def Verbe_Research(Verbe):
        Mot_Recherche = Verbe+'\n'
        Mot_Recherche.lower()
        try:
            f = open("../BDD/Linguistique/Dictionnaire/Verbes/Listing_Verbes_Fr-"+Mot_Recherche[0]+".txt", 'r')
            j = len(f.readlines())
            f.close
        except IOError:
            print "Cindy > Des fichiers semblent absents !!"
            raw_input('')
        i = 0
        while i < j:
                f = open("../BDD/Linguistique/Dictionnaire/Verbes/Listing_Verbes_Fr-"+Mot_Recherche[0]+".txt", 'r')
                Mot = f.readlines()[i]
                if StringTraite(Mot) == StringTraite(Mot_Recherche):
                        return 'True'
                f.close
                i += 1
        try:
                f = open("../BDD/APPRENTISSAGE/Verbes/Listes_All.txt", "r")
                j = len(f.readlines())
                f.close
                i = 0
                while i < j:
                        f = open("../BDD/APPRENTISSAGE/Verbes/Listes_All.txt", "r")
                        Learn_Test = f.readlines()[i]
                        if StringTraite(Learn_Test) == StringTraite(Mot_Recherche):
                                return 'True'
                        f.close
                        i += 1
        except:
                pass
        return 'False'

####################################################
#Partie 2 : Analyse du Temps Utilise : Operationnel#
####################################################

def Analyse_Terminaison(User, Terminaison, Temps):
    User = StringTraite(User)
    Terminaison = StringTraite(Terminaison)
    i = 6
    while i > 0:
        if len(Terminaison) == i:
            Term_User = User[len(User)-i:len(User)]
            if Term_User == Terminaison:
                return Temps
        i -= 1
    return 0

def Temps_Analyse(User):
    User = StringTraite(User)
    i = 0
    while i < len(BDD_Terminaison_Verbes[i]):
        if User[len(User)-2:len(User)] == BDD_Terminaison_Verbes[i] or User[len(User)-3:len(User)] == BDD_Terminaison_Verbes[i]:
            return "Infinitif"
        i += 1
    BDD_Temps_Type = ["Infinitif_Passe_BDD", "Indicatif_Present_BDD", "Indicatif_Passe_Simple_BDD", "Indicatif_Imparfait_BDD", "Indicatif_Futur_Simple_BDD", "Conditionnel_Present_BDD"]
    BDD_Temps = [Infinitif_Passe_BDD, Indicatif_Present_BDD, Indicatif_Passe_Simple_BDD, Indicatif_Imparfait_BDD, Indicatif_Futur_Simple_BDD, Conditionnel_Present_BDD]
    i = len(BDD_Temps)-1
    while i > 0:
            j = 0
            while j < len(BDD_Temps[i])-1:
                if Analyse_Terminaison(StringTraite(User), StringTraite(BDD_Temps[i][j]), StringTraite(BDD_Temps_Type[i])) == BDD_Temps_Type[i]:
                    return BDD_Temps_Type[i]
                j += 1
            i -= 1
    return 0

###################################################
#Partie 3 : Analyse des Auxiliaires : Operationnel#
###################################################

def Avoir_Analyse(User):
    Temps_Avoir = [BDD_Avoir_Indicatif_Present,BDD_Avoir_Indicatif_Passe_Compose,BDD_Avoir_Indicatif_Imparfait,BDD_Avoir_Indicatif_Plus_que_Parfait,BDD_Avoir_Indicatif_Passe_Simple,BDD_Avoir_Indicatif_Passe_Anterieur,BDD_Avoir_Indicatif_Futur_Simple,BDD_Avoir_Indicatif_Futur_Anterieur,BDD_Avoir_Subjonctif_Present,BDD_Avoir_Subjonctif_Passe,BDD_Avoir_Subjonctif_Imparfait,BDD_Avoir_Subjonctif_Plus_que_Parfait,BDD_Avoir_Imperatif_Present,BDD_Avoir_Imperatif_Passe,BDD_Avoir_Conditionnel_Present,BDD_Avoir_Conditionnel_Passe_Un,BDD_Avoir_Conditionnel_Passe_Deux,BDD_Avoir_Participe_Present,BDD_Avoir_Participe_Passe]
    User = User.lower()
    i = 0
    while i < len(Temps_Avoir):
        j = 0
        while j < len(Temps_Avoir[i]):
            if StringTraite(Temps_Avoir[i][j]) in StringTraite(User):
                print "Cindy > Auxiliaire 'AVOIR' detecte dans la Phrase."
            j += 1
        i += 1
    return 0

def Etre_Analyse(User):
    Temps_Etre = [BDD_Etre_Indicatif_Present,BDD_Etre_Indicatif_Passe_Compose,BDD_Etre_Indicatif_Imparfait,BDD_Etre_Indicatif_Plus_que_Parfait,BDD_Etre_Indicatif_Passe_Simple,BDD_Etre_Indicatif_Passe_Anterieur,BDD_Etre_Indicatif_Futur_Simple,BDD_Etre_Indicatif_Futur_Anterieur,BDD_Etre_Subjonctif_Present,BDD_Etre_Subjonctif_Passe,BDD_Etre_Subjonctif_Imparfait,BDD_Etre_Subjonctif_Plus_que_Parfait,BDD_Etre_Imperatif_Present,BDD_Etre_Imperatif_Passe,BDD_Etre_Conditionnel_Present,BDD_Etre_Conditionnel_Passe_Un,BDD_Etre_Conditionnel_Passe_Deux,BDD_Etre_Participe_Present,BDD_Etre_Participe_Passe]
    User = User.lower()
    i = 0
    while i < len(Temps_Etre):
        j = 0
        while j < len(Temps_Etre[i]):
            if StringTraite(Temps_Etre[i][j]) in StringTraite(User):
                print "Cindy > Auxiliaire 'ETRE' detecte dans la Phrase."
            j += 1
        i += 1
    return 0

##################################################
#Partie 4 : Conjugaison On the Fly : Operationnel#
#######################################################
#Retrouve un Verbe Original a partir du Verbe Conjugue#
#######################################################

def Conjug_On_The_Fly(User):
    User = StringTraite(User)
    User = User.lower()
    Temps = Temps_Analyse(User)
    if Temps == "Infinitif":
	    return User
    BDD_Temps_Base = [Infinitif_Passe_BDD, Indicatif_Present_BDD, Indicatif_Passe_Simple_BDD, Indicatif_Imparfait_BDD, Indicatif_Futur_Simple_BDD, Conditionnel_Present_BDD]
    BDD_Temps = ["Infinitif_Passe_BDD", "Indicatif_Present_BDD", "Indicatif_Passe_Simple_BDD", "Indicatif_Imparfait_BDD", "Indicatif_Futur_Simple_BDD", "Conditionnel_Present_BDD"]
    j = 0
    while j < len(BDD_Temps):
        if Temps == BDD_Temps[j]:
            k = 0
            while k < len(BDD_Temps_Base[j]):
                Terminaison = StringTraite(BDD_Temps_Base[j][k])
                if len(User) > len(Terminaison)+1:
                    try:
                        Verbe = User
                        t = 0
                        while t < len(BDD_Terminaison_Verbes):
                            Verbe = Verbe.replace(StringTraite(Terminaison), BDD_Terminaison_Verbes[t])
                            if Verbe_Research(Verbe) == 'True':
                                return Verbe
                            else:
                                Verbe = User
                            t += 1
                    except:
                        pass
                k += 1
        j += 1
    return 0

#################
#-Phase de Test-#
#################
print "Verbe Original : %s" %Conjug_On_The_Fly("aimes")
raw_input('')
